/*
 * IRMP_XMEGA.c
 *
 * Created: 06.02.2015 17:26:38
 *  Author: Matthias
 */ 

#define F_CPU 32000000

#define taster_port							PORTH.IN
#define taster_pin							7

#define Infrarot_led_pin					1
#define Infrarot_led_port					PORTD.OUT
#define Infrarot_led_dir					PORTD.DIR

#define Infrarot_empfaenger_pin				5
#define Infrarot_empfaenger_port			PORTE.IN
#define Infrarot_empfaenger_versorgung_pin	6
#define Infrarot_empfaenger_versorgung_port	PORTE.OUT

#include <avr/io.h>
#include <stdlib.h>			//itoa() und dtostrf()
#include "irmp.h"
#include "irsnd.h"
#include "LCD_Library_MF.h"

#define set_bit(ADDRESS,BIT) 	ADDRESS |= (1<<BIT)	// set Bit
#define clear_bit(ADDRESS,BIT) 	ADDRESS &= ~(1<<BIT)// clear Bit
#define invert_bit(ADDRESS,BIT)	ADDRESS ^= (1<<BIT)	// Bit umschalten
#define BitIsSet(ADRESS,BIT)	(ADRESS & (1<<BIT))	// berprft ob ein Bit gesetzt ist
#define BitIsClr(ADRESS,BIT)	(!(ADRESS & (1<<BIT)))// berprft ob ein Bit gelscht ist



void Clock_init(void)
{
	OSC.CTRL |= OSC_RC32MEN_bm;
	while(!(OSC.STATUS & OSC_RC32MRDY_bm));
	CCP = CCP_IOREG_gc;
	CLK.CTRL = CLK_SCLKSEL_RC32M_gc;
}

void init_timer_1(void)
{	//15khz = 66,66666us
	TCF0.CTRLA = TC_CLKSEL_DIV64_gc;
	TCF0.CTRLB = 0x00;
	TCF0.INTCTRLA = 0x01; //Niedrige Prioritt
	TCF0.PER = 0x21; //33 dez
}

ISR(TCF0_OVF_vect) //Timer 
{
	if (! irsnd_ISR())          // call irsnd ISR
	{                           // if not busy...
		irmp_ISR();             // call irmp ISR
	}
	// call other timer interrupt routines...
}	

char wert[7];

//void init_timer_pwm (void)  //Nur zum Testen. Kann wieder gelscht werden, da nicht bentigt.
//{
	////Ausgnge deklarieren nicht vergessen :P fehlt auf Kampis Elektroecke
	//set_bit (PORTD.DIR, 0);
	//set_bit (PORTD.DIR, 1);
	//set_bit (PORTD.DIR, 2);
	//set_bit (PORTD.DIR, 3);
	//
	//TCD0.PER = 0xFFFF; //Frequenz
	//TCD0.CTRLA = TC_CLKSEL_DIV1_gc; //System Clock
	//
	//TCD0.CTRLB |= TC0_CCAEN_bm; //Compare A freigeben
	//TCD0.CTRLB |= TC0_CCBEN_bm; //Compare B freigeben
	//TCD0.CTRLB |= TC0_CCCEN_bm; //Compare C freigeben
	//TCD0.CTRLB |= TC0_CCDEN_bm; //Compare D freigeben
	//
	//TCD0.CTRLB |= TC_WGMODE_FRQ_gc; //Singelslope
//}

int main(void)
{
	sei();
	PMIC.CTRL |= PMIC_LOLVLEN_bm | PMIC_MEDLVLEN_bm | PMIC_HILVLEN_bm;
	
	IRMP_DATA irmp_data;
	
	Clock_init();
	
	//Da mein IR Empfnger seine Spannung von einem der Ausgangspins holt, muss dieser Pin auf High geschaltet werden
	set_bit(PORTE.DIR,Infrarot_empfaenger_versorgung_pin); //Als Ausgang
	set_bit(Infrarot_empfaenger_versorgung_port, Infrarot_empfaenger_versorgung_pin); //Ausgang setzen
	
	//Ausgnge deklarieren nicht vergessen :P fehlt auf Kampis Elektroecke
	//Fr Infrarot LED
	set_bit (Infrarot_led_dir, Infrarot_led_pin);
	
	irmp_init(); 
	irsnd_init();
	
	init_timer_1();
	init_lcd();

	lcd_display_loeschen();
	
	while(1)
    {
		if (irmp_get_data (&irmp_data))
		//if (irmp_data.flags & IRMP_FLAG_REPETITION)
		{
			lcd_cursor_position(Zeile_1);
			lcd_string("Protokoll:");
			lcd_cursor_position(10);
			lcd_string(dtostrf(irmp_data.protocol, 5, 0, wert));
			lcd_cursor_position(Zeile_2);
			lcd_string("Adresse:");
			lcd_cursor_position(30);
			lcd_string(dtostrf(irmp_data.address, 5, 0, wert));
			lcd_cursor_position(Zeile_3);
			lcd_string("Command:");
			lcd_cursor_position(50);
			lcd_string(dtostrf(irmp_data.command, 5, 0, wert));
			
			irmp_data.flags = 0;    // reset flags!
			irsnd_send_data (&irmp_data, TRUE);                                 // send frame, wait for completion
			//_delay_ms (1000);
		}
    }
}