
//c-datei muss ber add --> existing item eingefgt werden

#include <avr/io.h>
#include "LCD_Library_MF.h"


#define F_CPU 32000000
#include <util/delay.h>


//*************************************************************************//
//Folgende defines knnen bei doppelbelegung auch einfach hier gelscht werden
#define set_bit(ADDRESS,BIT) 	ADDRESS |= (1<<BIT)	// set Bit
#define clear_bit(ADDRESS,BIT) 	ADDRESS &= ~(1<<BIT)// clear Bit
#define invert_bit(ADDRESS,BIT)	ADDRESS ^= (1<<BIT)	// Bit umschalten
#define BitIsSet(ADRESS,BIT)	(ADRESS & (1<<BIT))	// berprft ob ein Bit gesetzt ist
#define BitIsClr(ADRESS,BIT)	(!(ADRESS & (1<<BIT)))// berprft ob ein Bit gelscht ist
//***************************************************************************//

void alle_pins_low (void) //setzt alle Pins auf Low. Somit kann der berblick besser behalten werden
{
	clear_bit(LCD_DATA0_PORT, LCD_DATA0_PIN);
	clear_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	clear_bit(LCD_DATA2_PORT, LCD_DATA2_PIN);
	clear_bit(LCD_DATA3_PORT, LCD_DATA3_PIN);
	clear_bit(LCD_RS_PORT, LCD_RS_PIN);
	//clear_bit(LCD_RW_PORT, LCD_RW_PIN);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
}

void init_lcd (void)  
//Initialisiert Display. Wie im Link beschrieben 
//wird zu erst der 8Bit Modus aktiviert
{					  
	//setze alle Pins auf Ausgang
	set_bit(LCD_DATA0_DDR, LCD_DATA0_PIN);
	set_bit(LCD_DATA1_DDR, LCD_DATA1_PIN);
	set_bit(LCD_DATA2_DDR, LCD_DATA2_PIN);
	set_bit(LCD_DATA3_DDR, LCD_DATA3_PIN);
	set_bit(LCD_RS_DDR, LCD_RS_PIN);
	//set_bit(LCD_RW_DDR, LCD_RW_PIN);
	set_bit(LCD_E_DDR, LCD_E_PIN);

	_delay_ms(500); //Ohne diese Wartezeit kommt es seltsamerweie zu Fehlern
	//8Bit Modus
	_delay_ms(15);
	alle_pins_low();
	set_bit(LCD_DATA0_PORT, LCD_DATA0_PIN);
	set_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit_Befehle);
	
	//8Bit Modus
	_delay_ms(4);
	alle_pins_low();
	set_bit(LCD_DATA0_PORT, LCD_DATA0_PIN);
	set_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit_Befehle);
	
	//8Bit Modus
	_delay_us(100);
	alle_pins_low();
	set_bit(LCD_DATA0_PORT, LCD_DATA0_PIN);
	set_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit_Befehle);
	
	//4Bit Modus
	alle_pins_low();
	set_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit_Befehle);
	
	
	//2-zeilig, 5x8-Punkt-Matrix
	alle_pins_low();
	set_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	
	clear_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	set_bit(LCD_DATA3_PORT, LCD_DATA3_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit_Befehle);
	
	//Kursor nach rechts wandernd, kein Display shif
	alle_pins_low();
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	
	set_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	set_bit(LCD_DATA2_PORT, LCD_DATA2_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit_Befehle);
	
	//Display lschen
	alle_pins_low();
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	
	set_bit(LCD_DATA0_PORT, LCD_DATA0_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_ms(2);
	
	//Display ein
	alle_pins_low();
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	
	set_bit(LCD_DATA2_PORT, LCD_DATA2_PIN);
	set_bit(LCD_DATA3_PORT, LCD_DATA3_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit_Befehle);
}

void lcd_display_loeschen (void)
{
	alle_pins_low();
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	
	set_bit(LCD_DATA0_PORT, LCD_DATA0_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_ms(2);
}

void lcd_cursor_position (uint8_t position)
{
	//Curser auf Startposition
	alle_pins_low();
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	
	set_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit_Befehle);
	
	//Curser auf neue Position
	for (;position >0;position--)
	{
		alle_pins_low();
		set_bit(LCD_DATA0_PORT, LCD_DATA0_PIN);
		_delay_us(LCD_Zeit);
		set_bit(LCD_E_PORT, LCD_E_PIN);
		_delay_us(LCD_Zeit);
		clear_bit(LCD_E_PORT, LCD_E_PIN);
		
		alle_pins_low();
		set_bit(LCD_DATA2_PORT, LCD_DATA2_PIN);
		_delay_us(LCD_Zeit);
		set_bit(LCD_E_PORT, LCD_E_PIN);
		_delay_us(LCD_Zeit);
		clear_bit(LCD_E_PORT, LCD_E_PIN);
		_delay_us(LCD_Zeit_Befehle);
	}
	
}

void lcd_ausgeben (uint8_t zeichen)
{
	//Umlaute anpassen
	if (zeichen == '') zeichen =91;
	if (zeichen == '') zeichen =123;
	if (zeichen == '') zeichen =94;
	if (zeichen == '') zeichen =126;
	if (zeichen == '') zeichen =92;
	if (zeichen == '') zeichen =124;
	if (zeichen == '') zeichen =190;
	if (zeichen == '') zeichen =143;
	
	alle_pins_low();
	set_bit (LCD_RS_PORT, LCD_RS_PIN);
	if (BitIsSet(zeichen, 7)) set_bit(LCD_DATA3_PORT, LCD_DATA3_PIN);
	if (BitIsSet(zeichen, 6)) set_bit(LCD_DATA2_PORT, LCD_DATA2_PIN);
	if (BitIsSet(zeichen, 5)) set_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	if (BitIsSet(zeichen, 4)) set_bit(LCD_DATA0_PORT, LCD_DATA0_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	
	alle_pins_low();
	set_bit (LCD_RS_PORT, LCD_RS_PIN);
	if (BitIsSet(zeichen, 3)) set_bit(LCD_DATA3_PORT, LCD_DATA3_PIN);
	if (BitIsSet(zeichen, 2)) set_bit(LCD_DATA2_PORT, LCD_DATA2_PIN);
	if (BitIsSet(zeichen, 1)) set_bit(LCD_DATA1_PORT, LCD_DATA1_PIN);
	if (BitIsSet(zeichen, 0)) set_bit(LCD_DATA0_PORT, LCD_DATA0_PIN);
	_delay_us(LCD_Zeit);
	set_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit);
	clear_bit(LCD_E_PORT, LCD_E_PIN);
	_delay_us(LCD_Zeit_Befehle);
}

void lcd_string (const char* string)
{
	uint8_t i=0;
	
	do
	{
		lcd_ausgeben(string[i]);
		i++;
	}while (string[i] != 0);
}

void lcd_array (int8_t array[])
{
	uint8_t i=0;

	do
	{
		lcd_ausgeben(array[i]);
		i++;
	}while (array[i] != 0);	
}



