#ifndef LCD_Library_MF_H
#define LCD_Library_MF_H

/*************************************************************************
 Title	:   Library fr HD44780U kompatible LCD Displays
 Author:    Matthias Frank
 File:	    
 Software:  AVR-GCC 
 Hardware:  ATxmega 
***************************************************************************/

/**

Diese Bibliothek untersttzt nur den 4-bit Modus.
Die 6 bentigten Pins knnen an unterschiedlichen Ports 
eines Controllers angeschlossen werden. (RW kann an Masse angeschlossen werden)
Allerdings muss in dieser H-Datei definiert werden, an welchen Pins das Display angeschlossen wurde.


Gute Erklrung zu HD44780U kompatible LCD Displays
http://www.sprut.de/electronic/lcd/

 

*/
#define LCD_PORT         PORTH				

#define LCD_DATA0_PORT   LCD_PORT.OUT		
#define LCD_DATA0_DDR	 LCD_PORT.DIR
#define LCD_DATA0_PIN    0					

#define LCD_DATA1_PORT   LCD_PORT.OUT		
#define LCD_DATA1_DDR	 LCD_PORT.DIR
#define LCD_DATA1_PIN    1					

#define LCD_DATA2_PORT   LCD_PORT.OUT		
#define LCD_DATA2_DDR	 LCD_PORT.DIR
#define LCD_DATA2_PIN    2					

#define LCD_DATA3_PORT   LCD_PORT.OUT		
#define LCD_DATA3_DDR	 LCD_PORT.DIR
#define LCD_DATA3_PIN    3					

#define LCD_RS_PORT      LCD_PORT.OUT		
#define LCD_RS_DDR		 LCD_PORT.DIR
#define LCD_RS_PIN	     4					

//RW wird in dieser Library nicht verwendet und kann mit Masse verbunden werden
//#define LCD_RW_PORT      LCD_PORT.OUT		
//#define LCD_RW_DDR	   LCD_PORT.DIR
//#define LCD_RW_PIN       5					

#define LCD_E_PORT       LCD_PORT.OUT		
#define LCD_E_DDR		 LCD_PORT.DIR
#define LCD_E_PIN        6					

#define LCD_Zeit		 5 //Zeit zum Umschalten fr Enable
#define LCD_Zeit_Befehle 50 //Zeit nach einem Befehl

#define Zeile_1	0
#define Zeile_2	20
#define Zeile_3	40
#define Zeile_4	60

//Unterprogramme
void init_lcd (void);
void lcd_display_loeschen (void);
void lcd_cursor_position (uint8_t position);
void lcd_string (const char* string);
void lcd_array (int8_t array[]);


#endif //LCD_Library_MF_H